"use strict";
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, state, kind, f) {
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a getter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot read private member from an object whose class did not declare it");
    return kind === "m" ? f : kind === "a" ? f.call(receiver) : f ? f.value : state.get(receiver);
};
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, state, value, kind, f) {
    if (kind === "m") throw new TypeError("Private method is not writable");
    if (kind === "a" && !f) throw new TypeError("Private accessor was defined without a setter");
    if (typeof state === "function" ? receiver !== state || !f : !state.has(receiver)) throw new TypeError("Cannot write private member to an object whose class did not declare it");
    return (kind === "a" ? f.call(receiver, value) : f ? f.value = value : state.set(receiver, value)), value;
};
var _PhantomWalletAdapter_provider, _PhantomWalletAdapter_skipPreflight;
Object.defineProperty(exports, "__esModule", { value: true });
exports.PhantomWalletAdapter = void 0;
const getProvider = () => {
    if ('phantom' in window) {
        const provider = window.phantom?.solana;
        if (provider?.isPhantom) {
            console.log('Phantom is installed');
            return provider;
        }
    }
    window.open('https://phantom.app/', '_blank');
};
class PhantomWalletAdapter {
    get walletAddr() {
        return __classPrivateFieldGet(this, _PhantomWalletAdapter_provider, "f").publicKey.toString();
    }
    get isConnected() {
        return __classPrivateFieldGet(this, _PhantomWalletAdapter_provider, "f").isConnected;
    }
    get provider() {
        return __classPrivateFieldGet(this, _PhantomWalletAdapter_provider, "f");
    }
    constructor(opts) {
        _PhantomWalletAdapter_provider.set(this, void 0);
        _PhantomWalletAdapter_skipPreflight.set(this, void 0);
        __classPrivateFieldSet(this, _PhantomWalletAdapter_provider, getProvider(), "f");
        __classPrivateFieldSet(this, _PhantomWalletAdapter_skipPreflight, opts.skipPreflight, "f");
    }
    async sendTransaction(tx, conn) {
        const { context: { slot: minContextSlot }, value: { blockhash, lastValidBlockHeight }, } = await conn.getLatestBlockhashAndContext();
        const signedTransaction = await __classPrivateFieldGet(this, _PhantomWalletAdapter_provider, "f").signTransaction(tx);
        const signature = await conn.sendRawTransaction(signedTransaction.serialize(), {
            skipPreflight: __classPrivateFieldGet(this, _PhantomWalletAdapter_skipPreflight, "f"),
        });
        await conn.confirmTransaction({ blockhash, lastValidBlockHeight, signature });
    }
    async connect() {
        await __classPrivateFieldGet(this, _PhantomWalletAdapter_provider, "f").connect();
    }
}
exports.PhantomWalletAdapter = PhantomWalletAdapter;
_PhantomWalletAdapter_provider = new WeakMap(), _PhantomWalletAdapter_skipPreflight = new WeakMap();
//# sourceMappingURL=phantom-wallet.js.map